//+------------------------------------------------------------------+
//|                                                     raysbars.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#include <stderror.mqh>
#include <stdlib.mqh>


  extern double dlots=0.1;
  extern double iStopLoss = 30;
  extern double iTakeProfit = 30;
  extern int iSlippage=3;
  extern int iMaxTrades=1;
  extern int iMagicNumber=1400;

  int iTradeSignal=0;
  int iOpenBuySignal=100;
  int iCloseBuySignal=-200;
  int iOpenSellSignal=300;
  int iCloseSellSignal=-400;
  int iNoSignal=-1;
  
  int ilastTradeType;
  int iTotalTrades;
  int iTotalSelectedTrades;
  int iTotalBuyTrades;
  int iTotalSellTrades;
  int ilastTradeOpenTime;
  int pos,NewBar1;  
 
  bool bOrderCloseStatus;

  double dTotalTradelots;
  double dTotalTradeSwap;
  double dTotalOpenProfit;

  double dlastTradeOpenPrice;
  double dlastTradeStoploss;
  double dlastTradeTakeProfit;
  double dlastTradeType;
  double dlastTradeTicket;
  double SymPoints,SymDigits;

  string Sym;
  string strLastTradeSymbol;
  string strLastTradeComment;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

 int init()
  {
//----
    iTotalTrades=1;
        NewBar1=1;

    //---- SET VARS
                Sym = OrderSymbol();
          SymPoints = MarketInfo( Sym, MODE_POINT  );
          SymDigits = MarketInfo( Sym, MODE_DIGITS );
      
              if( SymPoints == 0.001   ) { SymPoints = 0.01;   SymDigits = 3; }
         else if( SymPoints == 0.00001 ) { SymPoints = 0.0001; SymDigits = 5; }

      }

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+

  int deinit()
  {
   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
   
   int start()
     {    
  
  fnGetOpenTradeInfo();
   Function_New_Bar();
  fnOpenBuyLogic();
  fnOpenSellLogic();
   fnOpenOrders();
  fnCloseBuyLogic();
  fnCloseSellLogic();
  fnCloseOrders();
     
//-----------------------------
   return(0);
  }   
//+---------------------------------------------------   
//----------    Det new Bar 
//+---------------------------------------------------
   
  void Function_New_Bar()
    {
         Print( "     iTotalSelectedTrades -  NewBar1 ",iTotalSelectedTrades,"  ",NewBar1 );
     if (iTotalSelectedTrades==0){ return(0);}
    
     double New_Time;
     int f_New_Time,NewBar;
     bool f_New_Bar = false;
     if (New_Time!=Time[0])
      {
      New_Time = Time[0];
     f_New_Bar = true;
      
     Alert(Time[0]);
     }
 
    if (f_New_Bar==false)
    {
      Alert("Waiting for new bar");
        
       }else{
       Alert("New bar just Exist."); 
     }
     return(0);
    }


//+------------------------------------------------------------------+

 void fnGetOpenTradeInfo()
  {
     
     dTotalOpenProfit=0;
     dTotalTradelots =0;
     iTotalBuyTrades=0;
     iTotalSellTrades=0;
     dTotalTradeSwap=0;
     iTotalSelectedTrades=0;
     iTotalTrades=OrdersTotal();
     
     for(int pos=OrdersTotal()-1; pos>=0; pos--)
      {
   
      if(OrderSelect(pos, SELECT_BY_POS,MODE_TRADES)
       && OrderSymbol() == Symbol()
       && OrderMagicNumber() == iMagicNumber ) 
        {
 
       iTotalSelectedTrades++;            
       dTotalOpenProfit += OrderProfit();
       dTotalTradeSwap += OrderSwap();
       dTotalTradelots += OrderLots();
       
       if( OrderType() == OP_BUY )
        {
         iTotalBuyTrades++; 
         ilastTradeType = OP_BUY;
      }   
      
      if( OrderType() == OP_SELL )
        {
         iTotalSellTrades++; 
         ilastTradeType = OP_SELL;
      }
     }
    }
   }
  
//========================================
   
 
 void fnOpenBuyLogic()
     {

    if ( Ask>Close[1]+3*SymPoints )          
        {  
         iTradeSignal = iOpenBuySignal;
         Alert("  BUY SIGNAL   iOpenBuySignal; ",iOpenBuySignal);   
      }
     }
     
  
//========================================
      
  void fnOpenSellLogic()
        {
      if ( Bid<Close[1]-3*SymPoints )          
        {  
         iTradeSignal = iOpenSellSignal;
         Alert("  SELL SIGNAL   iOpenSellSignal; ",iOpenSellSignal);
       }
      }
    
 
//==========================================

  void fnCloseBuyLogic()
    {
     int NewBar1;
   if ( NewBar1==4 )
      iTradeSignal=iCloseBuySignal;
      
     }    
//==========================================
    
  void fnCloseSellLogic()
     {
     int NewBar1;
   if ( NewBar1==4 )
      iTradeSignal=iCloseSellSignal;
    }

//+---------------------------------------------
//                  Open Buy      
//+---------------------------------------------

  
 void fnOpenOrders() 
     { 
        Print( "  got here  fnOpenOrder  newbar  ",NewBar1 );
     
      int iOrderOpenStatus;
     string strErrorMessage;
     int iErrorNumber;
     bool bOrdercloseStatus;
  
     if ( iTradeSignal == iOpenBuySignal  
     &&  iTotalSelectedTrades<iMaxTrades 
     &&  NewBar1>0 )
          {   

        Print( "   Order_Op-Buy  1st iStopLoss  ",iStopLoss );
        
           double dBuyStopLoss = Bid-(iStopLoss*SymPoints);
          double dBuyTakeProfit = Ask+(iTakeProfit*SymPoints);

       Print( "   Order/Send = OP_Buy  Tp  ",dBuyTakeProfit );
        Print( "   Order/Send = OP_Buy  Ask  ",Ask );
//         Print( "   Order/Send = OP_Buy  SL  ",dBuyStopLoss );
//        Print( "   Order/Send = OP_Buy  Bid  ",Bid );
//        Print( "   Order/Send = OP_Buy  iTrade  ",iTradeSignal );
        
     iOrderOpenStatus = OrderSend(Symbol(),OP_BUY,dlots,Ask,iSlippage,dBuyStopLoss,dBuyTakeProfit,"RaysBar",iMagicNumber,0,Green);
          
        if( iOrderOpenStatus < 0)
            {
            iErrorNumber = GetLastError();
            strErrorMessage = ErrorDescription(iErrorNumber);
            Print( "Ordersend Failed: ", strErrorMessage );
          }
        else {NewBar1=0;}

         return;
         }
     
 
 //+-------------------- Open Sell ------------------------+ 
  
     if( iTradeSignal == iOpenSellSignal 
      &&  iTotalSelectedTrades<iMaxTrades 
      &&  NewBar1>0 )
         { 
        Print( "   Order = OP_SELL  1st iStoploss  ",iStopLoss );
        
           double dSellStopLoss = Ask - (iStopLoss*SymPoints);
          double dSellTakeProfit = Bid + (iTakeProfit*SymPoints);

       Print( "   Order/Send = OP_Sell  Tp  ",dSellTakeProfit );
        Print( "   Order/Send = OP_Buy  Bid  ",Bid );
//         Print( "   Order/Send = OP_Sell   iStopLoss  ",dSellStopLoss );
//        Print( "   Order/Send = OP_SELL   Ask  ",Ask );
//        Print( "   Order/Send = OP_Sell  iTrade  ",iTradeSignal );
              
    iOrderOpenStatus = OrderSend(Symbol(),OP_SELL,dlots,Ask,iSlippage,dSellStopLoss,dSellTakeProfit,"RaysBar",iMagicNumber,0,Red);    

        if( iOrderOpenStatus < 0)
           {
            iErrorNumber = GetLastError();
            strErrorMessage = ErrorDescription(iErrorNumber);
            Print( "Ordersend Failed: ", strErrorMessage );
          }
        else {NewBar1=0;}

          return;
        }
        }
           
         
   //+-------------------------------------------
   //        Close Buy/Sell  
   //+------------------------------------------- 
  
  
 void fnCloseOrders()
       {
     int iOrderOpenStatus;
     string strErrorMessage;
     int iErrorNumber;
     bool bOrdercloseStatus;
  
     if ( iTradeSignal == iCloseBuySignal || iTradeSignal == iCloseSellSignal )
         {    
       for(int pos=OrdersTotal()-1; pos>=0; pos--)
          {
        if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)
         && OrderSymbol() == Symbol()
         && OrderMagicNumber() == iMagicNumber )
           {
//+--------------------------------------------
//                        Close Buy
//+-------------------------------------------- 
        if(OrderType() == OP_BUY )
            {
          bOrderCloseStatus = OrderClose( OrderTicket(), OrderLots(), Bid, iSlippage, Red );
     
           if ( bOrderCloseStatus == false )
            {  
            iErrorNumber = GetLastError();
            strErrorMessage = ErrorDescription(iErrorNumber);
            Print( "OrderClose Failed: ", strErrorMessage );   
          }            
           return;
        }
        
//+--------------------------------------------
//                    Close Sell
//+--------------------------------------------
    
      if( OrderType() == OP_SELL )
         {
        bOrderCloseStatus = OrderClose( OrderTicket(), OrderLots(), Bid, iSlippage, Red );
   
         if( bOrderCloseStatus == false )
            { 
            iErrorNumber = GetLastError();
            strErrorMessage = ErrorDescription(iErrorNumber);
            Print( "OrderClose Failed: ", strErrorMessage );
         }    
          return;
        }
       }
      }
     }
    }
   
 
   